#!/bin/ksh
function yesterday {
YEAR=$1
MONTH=$2
DAY=$3
DAY=`expr "$DAY" - 1`
case "$DAY" in
        0)
           MONTH=`expr "$MONTH" - 1`
                case "$MONTH" in
                        0)
                           MONTH=12
                           YEAR=`expr "$YEAR" - 1`
                        ;;
                esac
        DAY=`cal $MONTH $YEAR | grep . | fmt -1 | tail -1`
esac
let YEAR=YEAR+0
let MONTH=MONTH+0
let DAY=DAY+0
printf "%d-%02d-%02d\n" $YEAR $MONTH $DAY
}

searchString=$1
includeWorkSize="false"

if [ $# -eq 0 -o $# -gt 2 ]
then
echo "Usage: $0 <search string> <includeSASWorkSize>"
echo "Where:"
echo "  <search string> is the string that identifies the SAS processes"
echo "  <includeSASWorkSize> if set to true will cause the disk size for SAS work to be included"
echo "Example: $0 sshd"
echo "         $0 sasexe true"
exit
fi

if [ $# -eq 2 ]
then
   includeWorkSize=$2
fi

export dateStr=`date -u '+%Y-%m-%d'`
export yesterdateStr=`date -u '+%Y %m %d'`
export yesterdateStr=`yesterday $yesterdateStr`
dn=`uname -n`

export IFS='
'
# get the execution date time as close the command execution as possible
export dataGatherDateStr=`date "+%a %b %d %H:%M:%S %Z %Y"`
for i in `ps -ef -o pid,etime,time,pcpu,vsz,pmem,args | grep $searchString | grep -v grep | grep -v "getProcessList.sh"`
do
pid=`echo $i | xargs | awk '{print $1}'`
etime=`echo $i | xargs | awk '{print $2}'`
ctime=`echo $i | xargs | awk '{print $3}'`
pcpu=`echo $i | xargs | awk '{print $4}'`
vsize=`echo $i | xargs | awk '{print $5}'`
pmem=`echo $i | xargs | awk '{print $6}'`
# args=`echo $i | xargs | awk '{print "$7" "$8" "$9}'`

one=`echo $etime | cut -d'-' -f1`
two=`echo $etime | cut -d'-' -f2`
if [ "$one" != "$two" ]
then
let days=$one
hoursMinutesSeconds=$two
else
let days=0
hoursMinutesSeconds=$one
fi

one=`echo $hoursMinutesSeconds | cut -d':' -f1`
two=`echo $hoursMinutesSeconds | cut -d':' -f2`
three=`echo $hoursMinutesSeconds | cut -d':' -f3`
if [ -n "$three" ]
then
let hours=$one
let minutes=$two
let seconds=$three
else
let hours=0
let minutes=$one
let seconds=$two
fi
let hours=$days*24+$hours
dt=$dateStr
printf "<process dataGathered=\"$dataGatherDateStr\" pid=\"$pid\" host=\"$dn\" elapsedtime=\"$hours:$minutes:$seconds\" cputime=\"$ctime\" pcpu=\"$pcpu\" vsize=\"$vsize\" pmem=\"$pmem\""
#
# START: Commented out when merge logic moved into the java code
#   for j in `grep SASPROCESS /sddshared/ProcessManager/logs/web.log | egrep "$yesterdateStr|$dateStr" | grep "\"$pid\""`
#   do
#      if [ -n "$j" ]
#      then
#         processEntry=`echo $j | cut -d']' -f2`
#         pid=`echo $processEntry | cut -d'"' -f2`
#         sdduid=`echo $processEntry | cut -d'"' -f4`
#         dt=`echo $processEntry | cut -d'"' -f6`
#         printf " sdduser=\"$sdduid\""
#      fi
#
#   done
#   printf " date=\"$dt\""
# END: Commented out when merge logic moved into the java code
#
   pidh=`printf "%X\n" $pid`
   work="/sddshared/sas_tmp/*work*00${pidh}_${dn}*"
   printf " sasworkpath=\"%s\"" $work

   util="/sddshared/sas_tmp/*util*00${pidh}_${dn}*"
   printf " sasutilpath=\"%s\"" $util

   if [ $includeWorkSize = "true" ]
   then
      worksize=`du -sk $work | awk '{print $1}'`
      printf " sasworksize=\"$worksize\" sasworksizeunits=\"KB\""
      utilsize=`du -sk $util | awk '{print $1}'`
      printf " sasutilsize=\"$utilsize\" sasutilsizeunits=\"KB\""
   fi

   printf "/>\n"

done

